#-*- coding:utf-8 -*-
# PyTalkTime.py
# Copyright (c) 2008-2014 masa 
# version = 0.02(0)

"""
This program is free software.This program is distributed 
WITHOUT ANY WARRANTY.You should use it on your own risk. 

You can modify/redistribute it under the terms of the 
GNU General Public License version 2 or later.
"""

# Please change this part according to your environment
ini_file = "E:\\Data\\masa\\PyTalkTime.ini"
sound_path = "E:\\Sounds\\ttsound\\"
dat_file = "E:\\Data\\masa\\PyTalkTime.dat"
# use this file when can not read dat file
DingDong_file = "00.mp3"
#Volume Initial value
VOL1 = 5 #for file except  '00.mp3'
VOL2 = 5 #for file '00.mp3'
#


import e32
import audio
import time
import re
import sysinfo
import os

script_lock = e32.Ao_lock()


def conf_read():
    global VOL1
    global VOL2

    # read ini file
    try :
        f = open(ini_file,'r')
        fData = f.read()
        f.close()
    except :
        return

    fData = unicode(fData)
    TalkTime_list = fData.split(u"\n")

    # search line of volume value
    for lnData in TalkTime_list:
        lnDatawk = re.sub(u"[ \t]+",u" ",lnData)
        Sdata = lnDatawk.split(u" ")

        if len(Sdata) < 2: continue # no Sdata[1] error
        if Sdata[0].upper() == u"VOLUME1":
            if int(Sdata[1]) <= 10: VOL1 = int(Sdata[1])
            else:                   VOL1 = 10
        if Sdata[0].upper() == u"VOLUME2":
            if int(Sdata[1]) <= 10: VOL2 = int(Sdata[1])
            else:                   VOL2 = 10


def main_proc():
    conf_read() # VOL1,VOL2
    wkt  = time.time() + 10  #calibrate time ex 9:59:58 -> 10:00:08
                             #add 10 (need larger than 2 (sec))
    stime = time.strftime('%H:%M', time.localtime(wkt))

    # read dat file
    try :
        f = open(dat_file,'r')
        fData = f.read()
        f.close()
    except :
        fData = stime + " " + DingDong_file + " " + DingDong_file

    fData = unicode(fData)
    TalkTime_list = fData.split(u"\n")

    # search line of current time
    for lnData in TalkTime_list:
        lnDatawk = re.sub(u"[ \t]+",u" ",lnData)
        Sdata = lnDatawk.split(u" ")
        if unicode(stime) == Sdata[0]:
            break
    else:
        Sdata = [unicode(stime),unicode(DingDong_file),unicode(DingDong_file)]


    def cb(prev, curr, err):
        if curr == 1: script_lock.signal()

    # play sound file (the first data of Sdata is hh:mm)

    for i in Sdata[1:]:
        Si = os.path.join(unicode(sound_path), i)
        S = audio.Sound.open(Si)
        # my 00.mp3's volume is very low
        if i == unicode(DingDong_file): S.set_volume(VOL2)
        else:                           S.set_volume(VOL1)

        S.play(1, 0, cb)
        script_lock.wait()
        S.close()

Profile = sysinfo.active_profile()
if Profile not in ["silent", "meeting", "offline"]:
    main_proc()

#appuifw.app.set_exit()
#sys.exit()

